/*
  Author: Peter Gebruers, aka "petergebruers". You can meet me here:

  https://forum.fibaro.com/index.php?/profile/1799-petergebruers/
  or here:
  https://forum.z-wave.me/memberlist.php?mode=viewprofile&u=564463
  or here:
  https://community.home-assistant.io/u/petergebruers
*/

#include "Arduino.h"

// Setup channel using a variable (instead of getter/setter)
// works on FW >= 2.1.5 only

byte BinarySensorValue1;
byte BinarySensorValue2;
byte BinarySensorValue3;
byte BinarySensorValue4;
byte BinarySensorValue5;
byte BinarySensorValue6;
byte BinarySensorValue7;

ZUNO_SETUP_CHANNELS(
  ZUNO_SENSOR_BINARY_MOTION(BinarySensorValue1),
  ZUNO_SENSOR_BINARY_MOTION(BinarySensorValue2),
  ZUNO_SENSOR_BINARY_MOTION(BinarySensorValue3),
  ZUNO_SENSOR_BINARY_MOTION(BinarySensorValue4),
  ZUNO_SENSOR_BINARY_MOTION(BinarySensorValue5),
  ZUNO_SENSOR_BINARY_MOTION(BinarySensorValue6),
  ZUNO_SENSOR_BINARY_MOTION(BinarySensorValue7)
);

ZUNO_DISABLE(WITH_CC_NOTIFICATION);

DWORD StartMs, DurationMs;
const int ReportingIntervalMs = 7500;
void setup()
{
  Serial.begin();
  StartMs = millis() - ReportingIntervalMs - 1;
}

void loop()
{
  DurationMs = millis() - StartMs;

  if (DurationMs > ReportingIntervalMs) {
    StartMs = millis();
    BinarySensorValue1 = (BinarySensorValue1 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(1);
    BinarySensorValue2 = (BinarySensorValue2 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(2);
    BinarySensorValue3 = (BinarySensorValue3 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(3);
    BinarySensorValue4 = (BinarySensorValue4 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(4);
    BinarySensorValue5 = (BinarySensorValue5 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(5);
    BinarySensorValue6 = (BinarySensorValue6 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(6);
    BinarySensorValue7 = (BinarySensorValue7 == 0x00) ? 0xFF : 0x00;
    zunoSendReport(7);
  }
}
